import json
import socket
from time import sleep

s = socket.socket()
host = '127.0.0.1'
port = 54321

s.connect((host,port))
s.send("NAME B00000000H")

f = s.makefile()

msg = json.loads(f.readline())
while msg['messagetype'] != "startofround":
  sleep(0.5)
  msg = json.loads(f.readline())
  #print msg['messagetype']
msg=json.loads(f.readline())
last = 0
prevx = 0
prevy = 0

#prevs = []
#for x in range(0,msg['gamestate']['map']['width']):
#  prevs.append([])
#  for y in range(0,msg['gamestate']['map']['height']):
#    prevs[x].append(0)
while True:
  try: 
    prevs = [[0 for x in range(0,msg['gamestate']['map']['width']+1)] for y in range(0,msg['gamestate']['map']['height']+1)]
  except:
    pass
  while msg['messagetype'] == 'stateupdate':
    themap=msg['gamestate']['map']['content']
    x = msg['gamestate']['you']['x']
    y = msg['gamestate']['you']['y']
    move = {'left' : 0,'right' : 0,'up' : 0,'down' : 0}
    
    if x > 0:
      if themap[y][x-1] == "|":
        move['left'] = -1000
    else:
      move['left'] = -1000

    if x < msg['gamestate']['map']['width']-1: 
      if themap[y][x+1] == "|":
        move['right'] = -1000
    else:
      move['right'] = -1000
    
    if y > 0:
      if themap[y-1][x] == "|":
        move['up'] = -1000
    else:
      move['up'] = -1000

    if y < msg['gamestate']['map']['height']-1:
      if themap[y+1][x] == "|":
        move['down'] = -1000
    else:
      move['down'] = -1000
  
    for ghost in msg['gamestate']['others']:
      if (ghost['isdangerous']) & (msg['gamestate']['you']['isdangerous']):
        c="x"
      elif ghost['isdangerous']:
        c="X"
      elif msg['gamestate']['you']['isdangerous']:
        c="E"
      else:
        c="x"
      themap[ghost['y']]=themap[ghost['y']][:ghost['x']]+c+themap[ghost['y']][ghost['x']+1:]

    themap[prevy]=themap[prevy][:prevx]+"|"+themap[prevy][prevx+1:]

    prevx = x
    prevy = y

    prevs[y][x] -= 10

    keepgoing = True    
    mx = 0
    my = 0
    while keepgoing:
      mx = mx - 1
      if mx + x < 0:
        keepgoing = False
      else:
        if themap[y+my][x+mx] == "|":
          keepgoing = False
        elif themap[y+my][x+mx] == ".":
          move['left'] += 20 / -mx 
        elif themap[y+my][x+mx] == "E":
          move['left'] += 500 / -mx 
        elif themap[y+my][x+mx] == "_":
          move['left'] += 5 / -mx
        elif themap[y+my][x+mx] == "o":
          move['left'] += 500 / -mx
        elif themap[y+my][x+mx] == "X":
          keepgoing = False
          move['left'] -= 500 / -mx
        elif themap[y+my][x+mx] == "x":
          keepgoing = False
          move['left'] -= 50 / -mx
        move['left'] += (prevs[y+my][x+mx] / (-mx))
  
    keepgoing = True    
    mx = 0
    my = 0
    while keepgoing:
      mx = mx + 1
      if mx + x + 1 >= msg['gamestate']['map']['width']:
        keepgoing = False
      else:
        if themap[y+my][x+mx] == "|":
          keepgoing = False
        elif themap[y+my][x+mx] == ".":
          move['right'] += 20 / mx
        elif themap[y+my][x+mx] == "E":
          move['right'] += 500 / mx
        elif themap[y+my][x+mx] == "_":
          move['right'] += 5 / mx
        elif themap[y+my][x+mx] == "o":
          move['right'] += 500 / mx
        elif themap[y+my][x+mx] == "X":
          keepgoing = False
          move['right'] -= 500 / mx
        elif themap[y+my][x+mx] == "x":
          keepgoing = False
          move['right'] -= 50 / mx
        move['right'] += prevs[y+my][x+mx] / mx 
  
    keepgoing = True    
    mx = 0
    my = 0
    while keepgoing:
      my = my - 1
      if my + y < 0:
        keepgoing = False
      else:
        if themap[y+my][x+mx] == "|":
          keepgoing = False
        elif themap[y+my][x+mx] == ".":
          move['up'] += 20 / -my
        elif themap[y+my][x+mx] == "E":
          move['up'] += 500 / -my
        elif themap[y+my][x+mx] == "_":
          move['up'] += 5 / -my
        elif themap[y+my][x+mx] == "o":
          move['up'] += 500 / -my
        elif themap[y+my][x+mx] == "X":
          keepgoing = False
          move['up'] -= 500 / -my
        elif themap[y+my][x+mx] == "x":
          keepgoing = False
          move['up'] -= 50 / -my
        move['up'] += prevs[y+my][x+mx] / (-my)
    
    keepgoing = True    
    mx = 0
    my = 0
    while keepgoing:
      my = my + 1
      if my + y + 1 >= msg['gamestate']['map']['height']:
        keepgoing = False
      else:
        if themap[y+my][x+mx] == "|":
          keepgoing = False
        elif themap[y+my][x+mx] == ".":
          move['down'] += 20 / my
        elif themap[y+my][x+mx] == "E":
          move['down'] += 500 / my
        elif themap[y+my][x+mx] == "_":
          move['down'] += 5 / my
        elif themap[y+my][x+mx] == "o":
          move['down'] += 500 / my
        elif themap[y+my][x+mx] == "X":
          keepgoing = False
          move['down'] -= 500 / my
        elif themap[y+my][x+mx] == "x":
          keepgoing = False
          move['down'] -= 50 / my
        move['down'] += prevs[y+my][x+mx] / my
  
    best = max(move.values())

    if move['left'] == best:
      s.send("LEFT\n")
      prev = 'left'
    elif move['right'] == best:
      s.send("RIGHT\n")
      prev = 'right'
    elif move['up'] == best:
      s.send("UP\n")
      prev = 'up'
    elif move['down'] == best:
      s.send("DOWN\n")
      prev = 'down'
    else:
      s.send("LEFT\n")
      prev = 'left'
      print 'error'
    #print max(move.values())
    #print move
    #print themap[y][x] 
    msg=json.loads(f.readline())
  sleep(0.05)
  msg=json.loads(f.readline())
